%define _smp_ncpus_max 6

%define oname webkitgtk

%define api 4.0

%define javascriptcoregtk_major 18
%define libjavascriptcoregtk %mklibname javascriptcoregtk %{api} %{javascriptcoregtk_major}
%define javascriptcoregtk_gir %mklibname javascriptcore-gir %{api}

%define webkit2_major 37
%define libwebkit2 %mklibname webkit2gtk %{api} %{webkit2_major}
%define webkit2_gir %mklibname webkit2gtk-gir %{api}

%define develname %mklibname -d webkit2

%define oversion 2.28.4

Name:		webkitgtk2
Version:	2.30.0
Release:	%mkrel 3
Summary:	GTK+ Web content engine library
License:	BSD and LGPLv2+
Group:		System/Libraries
Source0:	http://webkitgtk.org/releases/%{oname}-%{oversion}.tar.xz
Patch2:		no-env-shebang.patch
URL:		http://www.webkitgtk.org
BuildRequires:	pkgconfig(atk)
BuildRequires:	pkgconfig(atspi-2)
BuildRequires:	pkgconfig(egl)
BuildRequires:	pkgconfig(fontconfig)
BuildRequires:	pkgconfig(freetype2)
BuildRequires:	pkgconfig(gdk-2.0)
BuildRequires:	pkgconfig(gdk-3.0)
BuildRequires:	pkgconfig(gl)
BuildRequires:	pkgconfig(glesv2)
BuildRequires:	pkgconfig(gobject-introspection-1.0)
BuildRequires:	pkgconfig(gstreamer-1.0) >= 1.0.3
BuildRequires:	pkgconfig(gstreamer-app-1.0) >= 1.0.3
BuildRequires:	pkgconfig(gstreamer-audio-1.0) >= 1.0.3
BuildRequires:	pkgconfig(gstreamer-base-1.0) >= 1.0.3
BuildRequires:	pkgconfig(gstreamer-fft-1.0) >= 1.0.3
BuildRequires:	pkgconfig(gstreamer-gl-1.0) >= 1.5.0
BuildRequires:	pkgconfig(gstreamer-mpegts-1.0) >= 1.4.0
BuildRequires:	pkgconfig(gstreamer-pbutils-1.0) >= 1.0.3
BuildRequires:	pkgconfig(gstreamer-tag-1.0) >= 1.0.3
BuildRequires:	pkgconfig(gstreamer-video-1.0) >= 1.0.3
BuildRequires:	pkgconfig(gtk+-2.0)
BuildRequires:	pkgconfig(gtk+-3.0)
BuildRequires:	pkgconfig(gtk+-unix-print-3.0)
BuildRequires:	pkgconfig(gtk+-wayland-3.0)
BuildRequires:	pkgconfig(gtk+-x11-3.0)
BuildRequires:	pkgconfig(harfbuzz) >= 0.9.7
BuildRequires:	pkgconfig(harfbuzz-icu) >= 0.9.18
BuildRequires:	pkgconfig(icu-uc)
BuildRequires:	pkgconfig(libwebp)
BuildRequires:	pkgconfig(sqlite3)
BuildRequires:	pkgconfig(libwoff2dec)
BuildRequires:	pkgconfig(wayland-client)
BuildRequires:	pkgconfig(wayland-egl)
BuildRequires:	pkgconfig(wayland-server)
BuildRequires:	pkgconfig(gnutls)
BuildRequires:	bison >= 2.3
BuildRequires:	pkgconfig(cairo) >= 1.10.2
BuildRequires:	pkgconfig(libjpeg)
BuildRequires:	libsoup-devel >= 2.42.0
BuildRequires:	pkgconfig(libxml-2.0) >= 2.8.0
BuildRequires:	pkgconfig(libxslt) >= 1.1.7
BuildRequires:	pkgconfig(zlib)
BuildRequires:	pkgconfig(libpng)
BuildRequires:	hyphen-devel
BuildRequires:	pkgconfig(x11)
BuildRequires:	pkgconfig(xcomposite)
BuildRequires:	pkgconfig(xdamage)
BuildRequires:	pkgconfig(xrender)
BuildRequires:	pkgconfig(xt)
BuildRequires:	cmake
BuildRequires:	bubblewrap
BuildRequires:	gperf
BuildRequires:	lib64enchant2-devel
BuildRequires:  lib64geoclue2-devel
BuildRequires:  lib64gstreamer-plugins-bad1.0-devel
BuildRequires:  lib64notify-devel
BuildRequires:  lib64python-devel
BuildRequires:  lib64seccomp-devel 
BuildRequires:  lib64secret-devel
BuildRequires:  lib64upower-glib-devel
BuildRequires:  lib64usb-compat0.1-devel
BuildRequires:  python2-rpm-macros
BuildRequires:  ruby 
BuildRequires:  xdg-dbus-proxy 
   
%description
WebKitGTK+ is the port of the portable web rendering engine WebKit to the
GTK+ platform.

%package -n	%{develname}
Summary:	Development files for WebKit GTK+ port
Group:		Development/Libraries
Provides:	%{name}-devel = %{version}-%{release}
Provides:	libwebkit2gtk-devel = %{version}-%{release}
Requires:   %{name}

%description -n	%{develname}
The %{name}-devel package contains libraries, build data, and header
files for developing applications that use %{name}.


%prep
%setup -qn %{oname}-%{oversion}
%apply_patches

%build
%global optflags %(echo %{optflags} | sed 's/-g /-g1 /')

echo 'add_compile_definitions("U_DEFINE_FALSE_AND_TRUE=1")' >> Source/WTF/wtf/CMakeLists.txt
echo 'add_compile_definitions("U_DEFINE_FALSE_AND_TRUE=1")' >> Source/WebCore/CMakeLists.txt

%cmake \
    -DPORT=GTK \
    -DCMAKE_C_FLAGS_RELWITHDEBINFO="-DNDEBUG" \
    -DCMAKE_CXX_FLAGS_RELWITHDEBINFO="-DNDEBUG" \
    -DPYTHON_EXECUTABLE=%{_bindir}/python3 \
    -DUSE_WPE_RENDERER=OFF \
    -DUSE_SYSTEMD=OFF

%make_build

%install
%make_install -C build

%find_lang WebKit2GTK-%{api}

%files -f WebKit2GTK-%{api}.lang
%dir %{_libexecdir}/webkit2gtk-%{api}/
%{_libexecdir}/webkit2gtk-%{api}/WebKitNetworkProcess
%{_libexecdir}/webkit2gtk-%{api}/WebKitWebProcess
%dir %{_libdir}/webkit2gtk-%{api}/
%{_libdir}/webkit2gtk-%{api}/injected-bundle/libwebkit2gtkinjectedbundle.so
%{_bindir}/WebKitWebDriver
%{_libexecdir}/webkit2gtk-%{api}/jsc
%{_libexecdir}/webkit2gtk-%{api}/WebKitPluginProcess
%{_libdir}/libjavascriptcoregtk-%{api}.so.%{javascriptcoregtk_major}
%{_libdir}/libjavascriptcoregtk-%{api}.so.%{javascriptcoregtk_major}.*
%{_libdir}/libwebkit2gtk-%{api}.so.%{webkit2_major}
%{_libdir}/libwebkit2gtk-%{api}.so.%{webkit2_major}.*
%{_libdir}/girepository-1.0/JavaScriptCore-%{api}.typelib
%{_libdir}/girepository-1.0/WebKit2-%{api}.typelib
%{_libdir}/girepository-1.0/WebKit2WebExtension-%{api}.typelib


%files -n %{develname}
%{_includedir}/webkitgtk-%{api}
%{_libdir}/*-%{api}.so
%{_libdir}/pkgconfig/*-%{api}.pc
%{_datadir}/gir-1.0/*-%{api}.gir

%post
/sbin/ldconfig

%postun
/sbin/ldconfig


%changelog
* Fri Oct 08 2021 tex - 2.30.0-3pclos2021
- fix for new icu

* Fri Sep 19 2020 tex - 2.30.0-2pclos2020
- back down to 2.28.4 to fix pcc for now

* Sat Sep 12 2020 tex - 2.30.0-1pclos2020
- new version

* Mon Apr 27 2020 tex - 2.28.2-1pclos2020
- new version

* Sun Apr 19 2020 tex - 2.28.1-1pclos2020
- new version

* Wed Mar 11 2020 tex - 2.28.0-1pclos2020
- new version

* Sun Feb 23 2020 tex - 2.26.4-1pclos2020
- new version

* Thu Jan 23 2020 tex - 2.26.3-1pclos2020
- new version

* Wed Nov 06 2019 tex - 2.26.2-1pclos2019
- new version

* Sat Oct 05 2019 tex - 2.26.1-1pclos2019
- new version

* Sat Oct 05 2019 tex - 2.26.0-2pclos2019
- rebuild against updates

* Mon Sep 09 2019 tex - 2.26.0-1pclos2019
- new version

* Thu Aug 29 2019 tex - 2.24.4-1pclos2019
- new version

* Wed Jul 03 2019 tex - 2.24.3-1pclos2019
- new version

* Tue May 21 2019 tex - 2.24.2-1pclos2019
- new version

* Wed Apr 10 2019 tex 2.24.1-1pclos2019
- update bug and security fixes

* Fri Mar 29 2019 tex 2.24.0-3pclos2019
- rebuild with different build opts
